#!/bin/bash
#delete mysql components
#+------------------+
#| HOST             |
#| HOST_MLE         |
#| MLE              |
#| OEM              |
#| OS               |
#| PCR_WHITE_LIST   |
#| PCR_manifest     |
#| alerts           |
#| attest_request   |
#| audit_log        |
#| his_users        |
#| machine_cert     |
#| system_constants |
#+------------------+
TOP_DIR=$(cd $(dirname "$0") && pwd)
if [ $# -ne 1 ]; then
    echo "Usage: $TOP_DIR/$0 <oat_server_fqdn>"
    exit 1
fi
cliname="$1"

#mysql -e "select *  from oat_db.machine_cert;"
#mysql -e "select *  from oat_db.HOST;"
#mysql -e "select *  from oat_db.HOST_MLE;"
#mysql -e "select *  from oat_db.MLE;"
#mysql -e "select *  from oat_db.OEM;"
#mysql -e "select *  from oat_db.OS;"
#mysql -e "select *  from oat_db.PCR_WHITE_LIST;"
#mysql -e "select *  from oat_db.PCR_manifest;"

hostID=${hostID:-0}

#get hostID with name
getHostID()
{
  id="`mysql -e "select ID from oat_db.HOST where HOST_NAME='$1';" \
     | grep -v "ID"`"
  echo $id
}
hostID="`getHostID $cliname`"

if [ "$hostID" == "" ];then
 echo " hostname <$cliname> is not in mysql ..."
 exit 1
fi

mleID={mleID:-0}
#get mleID (array) with hostID
getMleID()
{
  id="`mysql -e "select MLE_ID from oat_db.HOST_MLE where HOST_ID='$1';" \
      | grep -v "MLE_ID"`"
  echo $id
}

mleID="`getMleID $hostID`"

oemID=${oemID:-""}
osID=${osID:-""}
pcrID=${pcrID:-""}
#get oem os pcr ID with mleID
getOemOsPcrID()
{
  interval=" "
  for i in $mleID;do
    oem="`mysql -e "select OEM_ID from oat_db.MLE where ID='$i';" \
            | grep -v "OEM_ID"`"
    os="`mysql -e "select OS_ID from oat_db.MLE where ID='$i';" \
            | grep -v "OS_ID"`"
    pcr="`mysql -e "select ID from oat_db.PCR_WHITE_LIST where MLE_ID='$i';" \
            | grep -v "ID"`"
    oemID+=$oem
    oemID+=$interval
    osID+=$os
    osID+=$interval
    pcrID+=$pcr
    pcrID+=$interval
  done
}
getOemOsPcrID

##delete
#delete Machine Cert
delMachineCert()
{
  mysql -e "delete from oat_db.machine_cert where machine_name='$1';"
}

delMachineCert "$cliname"

#delete Host
delHost()
{
  mysql -e "delete from oat_db.HOST where ID='$1';"
}

delHost "$hostID"

#delete mle 
delMle()
{
  for i in $1;do
    mysql -e "delete from oat_db.HOST_MLE where MLE_ID='$i';"
    mysql -e "delete from oat_db.MLE where ID='$i';"
  done
}

delMle "$mleID"

#delete oem 
delOem()
{
  for i in $1;do
    mysql -e "delete from oat_db.OEM where ID='$i';"
  done
}
delOem "$oemID"

#delete os 
delOS()
{
  for i in $1;do
    mysql -e "delete from oat_db.OS where ID='$i';"
  done
}
delOS "$osID"

#delete pcr
delPCR()
{
  for i in $pcrID;do
    mysql -e "delete from oat_db.PCR_WHITE_LIST where ID='$i';"
  done
}
delPCR "$pcrID"

